with Interfaces; use Interfaces;

package body CosNotifyComm_SequencePullSupplier_Hash is

   P : constant array (0 .. 1) of Natural :=
     (2, 4);

   T1 : constant array (0 .. 1) of Unsigned_8 :=
     (18, 3);

   T2 : constant array (0 .. 1) of Unsigned_8 :=
     (1, 17);

   G : constant array (0 .. 19) of Unsigned_8 :=
     (7, 0, 3, 0, 0, 0, 0, 6, 5, 0, 0, 0, 3, 0, 0, 6, 0, 1, 4, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 20;
         F2 := (F2 + Natural (T2 (K)) * J) mod 20;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 9;
   end Hash;

end CosNotifyComm_SequencePullSupplier_Hash;
